-- Pakoskyfrog 2013/02/23 11:56:23

------------------------------------------------------------
--  This is an example of cicular motion and time conversion

------------------------
--  Init
local H, M, S = 0, 0, 0
local timeTable = os.date("*t", os.time())

------------------------
--  Callbacks
function love.draw()
    love.graphics.setColor(255,255,255)
    love.graphics.print('os time = '..tostring(os.time()), 10,10)
    love.graphics.print('os date = '..os.date("%H:%M:%S"), 10,30)
    
    -- Clock background
    do
        love.graphics.setColor(255,255,255)
        love.graphics.circle('fill', love.graphics.getWidth()*0.5, love.graphics.getHeight()*0.5, 250, 32)
        love.graphics.setColor(255,0,0)
        love.graphics.setLineWidth(5)
        love.graphics.circle('line', love.graphics.getWidth()*0.5, love.graphics.getHeight()*0.5, 250, 128)
    end

    -- Clock hours tics
    do
        love.graphics.setColor(0,0,0)
        love.graphics.setLineWidth(7)
        local theta, x1,y1, x2,y2
        local r, R = 220, 240
        local ox, oy = love.graphics.getWidth()*0.5, love.graphics.getHeight()*0.5
        for i = 0, 3 do
            theta = i * math.pi/2
            x1 = r * math.cos(theta) + ox
            y1 = r * math.sin(theta) + oy
            x2 = R * math.cos(theta) + ox
            y2 = R * math.sin(theta) + oy
            love.graphics.line(x1,y1, x2,y2)
        end
    end
    
    -- Clock mins tics
    do
        love.graphics.setColor(0,0,0)
        love.graphics.setLineWidth(3)
        local theta, x1,y1, x2,y2
        local r, R = 230, 240
        local ox, oy = love.graphics.getWidth()*0.5, love.graphics.getHeight()*0.5
        for i = 0, 11 do
            theta = i * math.pi/6
            x1 = r * math.cos(theta) + ox
            y1 = r * math.sin(theta) + oy
            x2 = R * math.cos(theta) + ox
            y2 = R * math.sin(theta) + oy
            love.graphics.line(x1,y1, x2,y2)
        end
    end
    
    -- H
    do
        love.graphics.setColor(0,0,0,220)
        love.graphics.setLineWidth(10)
        local theta, x1,y1, x2,y2
        local r, R = 0, 150
        local ox, oy = love.graphics.getWidth()*0.5, love.graphics.getHeight()*0.5
        do
            theta = 2*math.pi/12 * (H+M/60) -math.pi/2
            x1 = r * math.cos(theta) + ox
            y1 = r * math.sin(theta) + oy
            x2 = R * math.cos(theta) + ox
            y2 = R * math.sin(theta) + oy
            love.graphics.line(x1,y1, x2,y2)
        end
    end
    -- M
    do
        love.graphics.setColor(0,0,0,200)
        love.graphics.setLineWidth(5)
        local theta, x1,y1, x2,y2
        local r, R = 0, 175
        local ox, oy = love.graphics.getWidth()*0.5, love.graphics.getHeight()*0.5
        do
            theta = 2*math.pi/60 * (M+S/60) -math.pi/2
            x1 = r * math.cos(theta) + ox
            y1 = r * math.sin(theta) + oy
            x2 = R * math.cos(theta) + ox
            y2 = R * math.sin(theta) + oy
            love.graphics.line(x1,y1, x2,y2)
        end
    end
    -- S
    do
        love.graphics.setColor(200,0,0,220)
        love.graphics.setLineWidth(1)
        local theta, x1,y1, x2,y2
        local r, R = 0, 200
        local ox, oy = love.graphics.getWidth()*0.5, love.graphics.getHeight()*0.5
        do
            theta = 2*math.pi/60 * (S) -math.pi/2
            x1 = r * math.cos(theta) + ox
            y1 = r * math.sin(theta) + oy
            x2 = R * math.cos(theta) + ox
            y2 = R * math.sin(theta) + oy
            love.graphics.line(x1,y1, x2,y2)
        end
    end
    
end

function love.update()
    timeTable = os.date("*t", os.time())
    
    H = timeTable.hour % 12
    M = timeTable.min
    S = timeTable.sec
end
